//+------------------------------------------------------------------
//|                                         Trend Quality B indicator
//|                                                            mladen 
//|                                    
//| as Published in TASC 22:04 article
//| Trend Quality indicator" by David Sepiashvili
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    8
#property indicator_color1     clrDeepSkyBlue
#property indicator_color2     clrGray
#property indicator_color3     clrSandyBrown
#property indicator_color4     clrGray
#property indicator_color5     clrDeepSkyBlue
#property indicator_color6     clrDeepSkyBlue
#property indicator_color7     clrSandyBrown
#property indicator_color8     clrSandyBrown
#property indicator_style1     STYLE_DOT
#property indicator_style2     STYLE_DOT
#property indicator_style3     STYLE_DOT
#property indicator_width5     3
#property indicator_width5     3
#property indicator_width6     3
#property indicator_width7     3

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame               = PERIOD_CURRENT;
extern int                TrendPeriod             =  14;
extern int                NoisePeriod             = 250;
extern double             CorrectionFactor        =   2;
extern int                FastLength              =   7;
extern int                SlowLength              =  15;
extern ENUM_APPLIED_PRICE Price                   = PRICE_CLOSE;
extern int                MinMaxPeriod            =  50;
extern double             LevelUp                 =  90;
extern double             LevelDown               =  10;
extern bool               Interpolate             = true;

//
//
//
//
//

double trendQ[];
double trendQua[];
double trendQub[];
double trendQda[];
double trendQdb[];
double levelUp[];
double levelMi[];
double levelDn[];
double state[];

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(9);
   SetIndexBuffer(0,levelUp);
   SetIndexBuffer(1,levelMi);
   SetIndexBuffer(2,levelDn);  
   SetIndexBuffer(3,trendQ);
   SetIndexBuffer(4,trendQua);
   SetIndexBuffer(5,trendQub);
   SetIndexBuffer(6,trendQda);
   SetIndexBuffer(7,trendQdb);
   SetIndexBuffer(8,state);
           
         //
         //
         //
         //
         //
      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
            
   IndicatorShortName(timeFrameToString(TimeFrame)+" Trend quality B1 ("+TrendPeriod+","+NoisePeriod+","+DoubleToStr(CorrectionFactor,2)+","+FastLength+","+SlowLength+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double work[][7];
#define _price  0
#define _emaf   1
#define _emas   2
#define _sign   3
#define _cpc    4
#define _trend  5
#define _dt     6

//
//
//
//
//

int start()
{
   int i,k,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { levelUp[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame==Period())
   {
      if (state[limit]== 1) CleanPoint(limit,trendQua,trendQub);
      if (state[limit]==-1) CleanPoint(limit,trendQda,trendQdb);
      if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);
         double alpha1 = 2.0 / (1.0+FastLength);
         double alpha2 = 2.0 / (1.0+SlowLength);
         
      //
      //
      //
      //
      //

      
      for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
      {
         work[r][_price] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         work[r][_emaf]  = work[r-1][_emaf]+alpha1*(work[r][_price]-work[r-1][_emaf]);
         work[r][_emas]  = work[r-1][_emas]+alpha2*(work[r][_price]-work[r-1][_emas]);
            double macd  = work[r][_emaf]-work[r][_emas];
                           work[r][_sign] = work[r-1][_sign];
                              if (macd>0) work[r][_sign] =  1;
                              if (macd<0) work[r][_sign] = -1;
      
            //
            //
            //
            //
            //
      
            double change = MathAbs(work[r][_price]-work[r-1][_price]);
            if (work[r][_sign] != work[r-1][_sign])
               {
                  work[r][_cpc]   = 0;
                  work[r][_trend] = 0;
               }
            else
               {
                  work[r][_cpc]   = work[r][_sign]*change+work[r-1][_cpc];
                  work[r][_trend] = work[r][_cpc]*(1.0/TrendPeriod)+work[r-1][_trend]*(1.0-(1.0/TrendPeriod));
               }
            work[r][_dt] = (work[r][_cpc]-work[r][_trend])*(work[r][_cpc]-work[r][_trend]);
         
            //
            //
            //
            //
            //
         
            double avgDt = 0; for (k=0; k<NoisePeriod; k++) avgDt += work[r-k][_dt]; avgDt /= NoisePeriod;
            double noise = CorrectionFactor*MathSqrt(avgDt);
            double temp  = 1; 
               if((MathAbs(work[r][_trend])+noise)!=0) temp = MathAbs(work[r][_trend])+noise;
                     trendQ[i]  = 100.0*(work[r][_trend])/temp;
                     double valMin = trendQ[ArrayMinimum(trendQ,MinMaxPeriod,i)];
                     double valMax = trendQ[ArrayMaximum(trendQ,MinMaxPeriod,i)];
                     double range  = valMax-valMin;
                        levelUp[i] = valMin+range*LevelUp/100.0;
                        levelMi[i] = valMin+range*0.5;
                        levelDn[i] = valMin+range*LevelDown/100.0;
               trendQda[i] = EMPTY_VALUE;                        
               trendQdb[i] = EMPTY_VALUE;                        
               trendQua[i] = EMPTY_VALUE;                        
               trendQub[i] = EMPTY_VALUE;                        
               state[i] = 0;
                  if (trendQ[i]>levelUp[i]) state[i] =  1;
                  if (trendQ[i]<levelDn[i]) state[i] = -1;
                  if (state[i] ==  1) PlotPoint(i,trendQua,trendQub,trendQ);
                  if (state[i] == -1) PlotPoint(i,trendQda,trendQdb,trendQ);
      }      
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         levelUp[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,TrendPeriod,NoisePeriod,CorrectionFactor,FastLength,SlowLength,Price,MinMaxPeriod,LevelUp,LevelDown,0,y);
         levelMi[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,TrendPeriod,NoisePeriod,CorrectionFactor,FastLength,SlowLength,Price,MinMaxPeriod,LevelUp,LevelDown,1,y);
         levelDn[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,TrendPeriod,NoisePeriod,CorrectionFactor,FastLength,SlowLength,Price,MinMaxPeriod,LevelUp,LevelDown,2,y);
         trendQ[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,TrendPeriod,NoisePeriod,CorrectionFactor,FastLength,SlowLength,Price,MinMaxPeriod,LevelUp,LevelDown,3,y);
         state[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,TrendPeriod,NoisePeriod,CorrectionFactor,FastLength,SlowLength,Price,MinMaxPeriod,LevelUp,LevelDown,8,y);
         trendQda[i] = EMPTY_VALUE;                        
         trendQdb[i] = EMPTY_VALUE;                        
         trendQua[i] = EMPTY_VALUE;                        
         trendQub[i] = EMPTY_VALUE;                        

         //
         //
         //
         //
         //
      
            if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,TimeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int m = 1; m < n; m++)
            {
               levelUp[i+m] = levelUp[i] + (levelUp[i+n]-levelUp[i])*m/n;
               levelMi[i+m] = levelMi[i] + (levelMi[i+n]-levelMi[i])*m/n;
               levelDn[i+m] = levelDn[i] + (levelDn[i+n]-levelDn[i])*m/n;
               trendQ[i+m]  = trendQ[i]  + (trendQ[i+n] -trendQ[i] )*m/n;
            }            
   }      
   for (i=limit;i>=0;i--)
   {
      if (state[i] ==  1) PlotPoint(i,trendQua,trendQub,trendQ);
      if (state[i] == -1) PlotPoint(i,trendQda,trendQdb,trendQ);
   }
   return(0);         
         
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}